var grid = Ext.getCmp('{{ component.grid.client_id }}');
var gridStore = grid.getStore();
var gridSM = grid.getSelectionModel();
var buildButton = Ext.getCmp('{{ component.grid.top_bar.button__build.client_id }}');


function switchBuildButton() {
    buildButton.setDisabled(!gridSM.hasSelection());
}
gridStore.on('load', switchBuildButton);
gridSM.on('selectionchange', switchBuildButton);


function buildReport() {
    if (gridSM.hasSelection()) {
        if (gridSM.getCount() > 1) {
            Ext.Msg.alert(
                'Сборка отчета',
                'Должен быть выбран только один элемент.'
            );
        } else {
            var mask = new Ext.LoadMask(win.body);
            mask.show();

            var record = gridSM.getSelected();
            var params = {m3_window_id: win.id};
            params[grid.rowIdName] = record.id;

            Ext.Ajax.request({
                timeout: 1000 * 60 * 30,
                url: '{{ component.build_action_url }}',
                params: params,
                success: function(response, options) {
                    try {
                        smart_eval(response.responseText);
                    } finally {
                        mask.hide();
                    }
                },
                failure: function() {
                    uiAjaxFailMessage.apply(this, arguments);
                    mask.hide();
                }
            });
        }
    }
}
